/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.kaki.client.gui;

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.eof.EOLolfNomenclatureDepense;
import org.cocktail.application.client.eof.EOOrgan;
import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.kaki.client.metier.EOCodeAnalytique;
import org.cocktail.kaki.client.metier.EOConvention;
import org.cocktail.kaki.client.metier.EOPafAgentLbud;
import org.cocktail.kaki.common.KakiConstantes;
import org.cocktail.kaki.common.KakiIcones;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class AgentsBudgetView extends javax.swing.JPanel {

    
    /**
	 * 
	 */
	private static final long serialVersionUID = 8617977467006037629L;
	protected EODisplayGroup eod;
	protected ZEOTable myEOTable;
	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;
	private boolean useSifac;

    /** Creates new form AgentsBudgetView */
    public AgentsBudgetView(EODisplayGroup displayGroup, boolean useSifac) {
        
        initComponents();
        setUseSifac(useSifac);
        eod  = displayGroup;
        
        initGui();
    }

    public boolean isUseSifac() {
		return useSifac;
	}

	public void setUseSifac(boolean useSifac) {
		this.useSifac = useSifac;
	}

	/** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTable = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        buttonAddLbud = new javax.swing.JButton();
        buttonUpdateLbud = new javax.swing.JButton();
        buttonDelLbud = new javax.swing.JButton();
        buttonLbudAuto = new javax.swing.JButton();
        lblMessage = new javax.swing.JLabel();
        checkCompta = new javax.swing.JCheckBox();
        checkPrincipale = new javax.swing.JCheckBox();
        buttonLastLbud = new javax.swing.JButton();
        buttonChargesAPayer = new javax.swing.JButton();
        temCap = new javax.swing.JCheckBox();

        viewTable.setLayout(new java.awt.BorderLayout());

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 12));
        jLabel1.setForeground(new java.awt.Color(0, 153, 153));
        jLabel1.setText("Informations Budgétaires");

        buttonAddLbud.setToolTipText("Ajout d'une nouvelle ligne budgétaire");
        buttonAddLbud.setMaximumSize(new java.awt.Dimension(33, 23));
        buttonAddLbud.setMinimumSize(new java.awt.Dimension(33, 23));
        buttonAddLbud.setPreferredSize(new java.awt.Dimension(33, 23));

        buttonUpdateLbud.setToolTipText("Modification de la ligne budgétaire");
        buttonUpdateLbud.setMaximumSize(new java.awt.Dimension(33, 21));
        buttonUpdateLbud.setMinimumSize(new java.awt.Dimension(33, 21));
        buttonUpdateLbud.setPreferredSize(new java.awt.Dimension(33, 21));

        buttonDelLbud.setToolTipText("Suppression de la ligne budgétaire");
        buttonDelLbud.setMaximumSize(new java.awt.Dimension(33, 21));
        buttonDelLbud.setMinimumSize(new java.awt.Dimension(33, 21));
        buttonDelLbud.setPreferredSize(new java.awt.Dimension(33, 21));

        buttonLbudAuto.setToolTipText("Déduction automatique Ligne Budgétaire");
        buttonLbudAuto.setMaximumSize(new java.awt.Dimension(33, 21));
        buttonLbudAuto.setMinimumSize(new java.awt.Dimension(33, 21));
        buttonLbudAuto.setPreferredSize(new java.awt.Dimension(33, 21));

        lblMessage.setForeground(new java.awt.Color(255, 0, 0));
        lblMessage.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);

        checkCompta.setText("Prise en compte comptable");

        checkPrincipale.setText("Ligne Principale");

        buttonLastLbud.setToolTipText("Déduction de la dernière ligne budgétaire connue");
        buttonLastLbud.setMaximumSize(new java.awt.Dimension(33, 21));
        buttonLastLbud.setMinimumSize(new java.awt.Dimension(33, 21));
        buttonLastLbud.setPreferredSize(new java.awt.Dimension(33, 21));

        buttonChargesAPayer.setToolTipText("Génération des charges à payer");
        buttonChargesAPayer.setMaximumSize(new java.awt.Dimension(33, 21));
        buttonChargesAPayer.setMinimumSize(new java.awt.Dimension(33, 21));
        buttonChargesAPayer.setPreferredSize(new java.awt.Dimension(33, 21));

        temCap.setText("BS passé en CAP");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jSeparator1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 753, Short.MAX_VALUE)
                            .add(layout.createSequentialGroup()
                                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 209, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 544, Short.MAX_VALUE))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 716, Short.MAX_VALUE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(buttonChargesAPayer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(buttonLastLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                            .add(buttonAddLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                            .add(buttonUpdateLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                            .add(buttonDelLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                        .add(buttonLbudAuto, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                                .add(8, 8, 8)))
                        .add(0, 0, 0))
                    .add(layout.createSequentialGroup()
                        .add(checkCompta, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 204, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(checkPrincipale, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 123, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(temCap, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 153, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(lblMessage, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 236, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(37, 37, 37))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(buttonAddLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonUpdateLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonDelLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonLbudAuto, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonLastLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonChargesAPayer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 168, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(checkPrincipale, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 25, Short.MAX_VALUE)
                        .add(temCap))
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(lblMessage, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(checkCompta, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonAddLbud;
    private javax.swing.JButton buttonChargesAPayer;
    private javax.swing.JButton buttonDelLbud;
    private javax.swing.JButton buttonLastLbud;
    private javax.swing.JButton buttonLbudAuto;
    private javax.swing.JButton buttonUpdateLbud;
    private javax.swing.JCheckBox checkCompta;
    private javax.swing.JCheckBox checkPrincipale;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel lblMessage;
    private javax.swing.JCheckBox temCap;
    private javax.swing.JPanel viewTable;
    // End of variables declaration//GEN-END:variables

        public javax.swing.JButton getButtonAddLbud() {
		return buttonAddLbud;
	}
        
	public javax.swing.JButton getButtonLbudAuto() {
			return buttonLbudAuto;
		}

		public void setButtonLbudAuto(javax.swing.JButton buttonLbudAuto) {
			this.buttonLbudAuto = buttonLbudAuto;
		}

	public void setButtonAddLbud(javax.swing.JButton buttonAddLbud) {
		this.buttonAddLbud = buttonAddLbud;
	}

	public javax.swing.JButton getButtonDelLbud() {
		return buttonDelLbud;
	}

	public void setButtonDelLbud(javax.swing.JButton buttonDelLbud) {
		this.buttonDelLbud = buttonDelLbud;
	}

	public javax.swing.JButton getButtonUpdateLbud() {
		return buttonUpdateLbud;
	}

	public javax.swing.JCheckBox getCheckCompta() {
		return checkCompta;
	}

	
	
	public javax.swing.JButton getButtonChargesAPayer() {
		return buttonChargesAPayer;
	}

	public void setButtonChargesAPayer(javax.swing.JButton buttonChargesAPayer) {
		this.buttonChargesAPayer = buttonChargesAPayer;
	}

	public javax.swing.JButton getButtonLastLbud() {
		return buttonLastLbud;
	}

	public void setButtonLastLbud(javax.swing.JButton buttonLastLbud) {
		this.buttonLastLbud = buttonLastLbud;
	}

	public javax.swing.JCheckBox getCheckPrincipale() {
		return checkPrincipale;
	}

	public void setCheckPrincipale(javax.swing.JCheckBox checkPrincipale) {
		this.checkPrincipale = checkPrincipale;
	}

	public void setCheckCompta(javax.swing.JCheckBox checkCompta) {
		this.checkCompta = checkCompta;
	}

	public void setButtonUpdateLbud(javax.swing.JButton buttonUpdateLbud) {
		this.buttonUpdateLbud = buttonUpdateLbud;
	}
        
              	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public javax.swing.JLabel getLblMessage() {
					return lblMessage;
				}

				public void setLblMessage(javax.swing.JLabel lblMessage) {
					this.lblMessage = lblMessage;
				}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}

 	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.univlr.karukera.client.ZKarukeraPanel#initGUI()
	 */
	private void initGui() {
		
		buttonAddLbud.setIcon(KakiIcones.ICON_ADD);		
		buttonUpdateLbud.setIcon(KakiIcones.ICON_UPDATE);
		buttonDelLbud.setIcon(KakiIcones.ICON_DELETE);
		buttonLbudAuto.setIcon(KakiIcones.ICON_WIZARD_22);
		buttonLastLbud.setIcon(KakiIcones.ICON_DUPLICATE);
		buttonChargesAPayer.setIcon(KakiIcones.ICON_PARAMS_16);

		buttonLastLbud.setToolTipText("Reprise lignes budgétaires du dernier mois");
		buttonChargesAPayer.setToolTipText("Génération du BS en Charges à Payer");
		
		temCap.setToolTipText("BS passé en totalité en CAP");
		
		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();
		
		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, EOPafAgentLbud.ORGAN_KEY + "."+ EOOrgan.ORG_UB_KEY, (isUseSifac())?"C.F":"UB", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafAgentLbud.ORGAN_KEY + "."+ EOOrgan.ORG_CR_KEY, (isUseSifac())?"C.C.":"CR", 75);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafAgentLbud.ORGAN_KEY + "."+ EOOrgan.ORG_SOUSCR_KEY, (isUseSifac())?"EOTP":"SOUS CR", 125);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafAgentLbud.LOLF_KEY+"."+EOLolfNomenclatureDepense.LOLF_CODE_KEY, "Action", 75);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafAgentLbud.CODE_ANALYTIQUE_KEY +"." + EOCodeAnalytique.CAN_CODE_KEY, "Canal", 110);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafAgentLbud.CONVENTION_KEY+"."+EOConvention.CON_INDEX_KEY, "Conv", 80);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafAgentLbud.PAGL_QUOTITE_KEY, "Quot", 50);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		
		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);
		
		myEOTable = new ZEOTable(myTableSorter);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		
		
		myEOTable.setBackground(KakiConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTable.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);		
		
		viewTable.setBorder(BorderFactory.createEmptyBorder());
		viewTable.removeAll();
		viewTable.setLayout(new BorderLayout());
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);
	
        }

	public javax.swing.JCheckBox getTemCap() {
		return temCap;
	}

	public void setTemCap(javax.swing.JCheckBox temCap) {
		this.temCap = temCap;
	}

}
